*****************************************************************************

* FILENAME: TM.S
* CONTENTS: Main program module.
* AUTHOR  : John Olwoch
* DATE    :
*****************************************************************************

*----------------------------------------------------------------------------
* NAME: TURING MACHINE
* FUNCTION: Simulates the action of a Turing machine.
* FLAGS USED:  31, =0: Command not found
*                  =1: Command found
*              32, =0: No left page available
*                  =1: Left page available
*              33, =0  No right page available
*                  =1: Right page available
*              34, =0:
*                  =1: view keys pressed
*              35, =0: "0" not displayed
*                  =1: "0" displayed
*              36, =0:
*                  =1:
*              37, =0:
*                  =1:
* STACK OPERATION: ( --> )
* CALLS:
* CALLED BY: User
*----------------------------------------------------------------------------

* Include the header file KEYDEFS.H

INCLUDE \SYS48\KEYDEFS.H

* Include the 8 chars needed for binary download.

ASSEMBLE
        NIBASC  /HPHP48-D/
RPL

:: 
  CK0NOLASTWD                           ( *No arguments expected* )
  ClrDA1IsStat                          ( *Suspend clock display* )
  RECLAIMDISP                           ( *Assert and clear alpha display* )

  INCLUDE TMVAR.S                       ( *variables* )
  INCLUDE TMSEC.S                       ( *secondaries* )
  INCLUDE TMKEY.S                       ( *key handlers* )

  LAM Setup EVAL                        ( *Set up the display* )

  ' DispMenu.1                          ( *Display action - show menu* )
  LAM KeyHandler                        ( *Hard key handler* )
  TrueFalse                             ( *App keys only* )
  LAM Softkeys                          ( *Soft keys* )
  ONEFALSE                              ( *1st row, no suspend* )
  ' LAM exit                            ( *App exit condition* )
  ' ERRJMP                              ( *Error handler* )
  ParOuterLoop                          ( *Run the ParOuterLoop* )

* Reset before leaving.

  ABND
  ABND
  ABND
  RECLAIMDISP
  ClrDAsOK                              ( *Redraw the lcd* )
;
