*****************************************************************************
* FILENAME: TMKEY.S
* CONTENTS:
* AUTHOR  : John Olwoch
* DATE    :
*****************************************************************************

*----------------------------------------------------------------------------
* NAME: KeyHandler
* FUNCTION: Hard key handler for POL.
* STACK OPERATION: ( --> )
* CALLS: none
* CALLED BY: POL
*----------------------------------------------------------------------------

'
::
  kpNoShift #=casedrop

  ::
    DUP#<7 casedrpfls                   ( *enable soft keys* )

    kcLeftArrow  ?CaseKeyDef            ( *Left?* )

      ::
	TakeOver
	34 SetUserFlag                  ( *set view flag* )
	LAM this_page 1 #> ITE
	::
	  LAM position 1 #-
	  ' LAM position STO
	  MINUSONE LAM New_page EVAL
	  LAM position 12 #-
	  ' LAM position STO
	;
	::
	  2.0 LAM Errmsg EVAL
	;
      ;

    kcRightArrow ?CaseKeyDef            ( *Right?* )

      ::
	TakeOver
	34 SetUserFlag                  ( *set view flag* )
	LAM this_page
	LAM last_page #< ITE
	::
	  LAM position 13 #+
	  ' LAM position STO
	  1 LAM New_page EVAL
	;
	::
	  2.0 LAM Errmsg EVAL
	;
      ;

    kcOn         ?CaseKeyDef            ( *Quit?* )

      ::
	TakeOver
	TRUE ' LAM exit STO             ( *Set up for exit* )
      ;

    kpNoShift    #=casedrpfls           ( *discard other keys* )

      DROP 'DoBadKeyT

  ;

  2DROP 'DoBadKeyT
;

*----------------------------------------------------------------------------
* NAME: Softkeys
* FUNCTION:
* STACK OPERATION: ( --> )
* CALLS: none
* CALLED BY: POL
*----------------------------------------------------------------------------
{

  {
    "RUN"
    ::
      TakeOver
      LAM move_direction "." EQUAL ITE
	::
	  1.1 LAM Errmsg EVAL
	;
	::
	  LAM this_page 1 #= ITE
	    ::
	      LAM T_machine EVAL
	    ;
	    ::
	      1.2 LAM Errmsg EVAL
	    ;
	;
    ;
  }

  NullMenuKey
  NullMenuKey
  NullMenuKey

  {
    "RESET"
    ::
      TakeOver
      CLEARVDISP                        ( *clear the display* )
      1 ' LAM position STO
      1 ' LAM scanner_pos STO
      1 ' LAM scanner_page STO
      1 ' LAM this_page STO
      "N" ' LAM move_direction STO
      "00" ' LAM next_state STO
      LAM Setup EVAL
    ;
  }

  { 
    "QUIT"
    :: 
      TakeOver 
      TRUE ' LAM exit STO 
    ; 
  }

}
*----------------------------------------------------------------------------
*
{ 
  LAM KeyHandler
  LAM Softkeys
} BIND


